package com.gxwebsoft.common.system.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.UserGradeService;
import com.gxwebsoft.common.system.entity.UserGrade;
import com.gxwebsoft.common.system.param.UserGradeParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 用户会员等级表控制器
 *
 * @author 科技小王子
 * @since 2023-10-07 22:51:17
 */
@Tag(name = "用户等级")
@RestController
@RequestMapping("/api/system/user-grade")
public class UserGradeController extends BaseController {
    @Resource
    private UserGradeService userGradeService;

    @Operation(summary = "分页查询用户会员等级表")
    @GetMapping("/page")
    public ApiResult<PageResult<UserGrade>> page(UserGradeParam param) {
        // 使用关联查询
        return success(userGradeService.pageRel(param));
    }

    @Operation(summary = "查询全部用户会员等级表")
    @GetMapping()
    public ApiResult<List<UserGrade>> list(UserGradeParam param) {
        // 使用关联查询
        return success(userGradeService.listRel(param));
    }

    @Operation(summary = "根据id查询用户会员等级表")
    @GetMapping("/{id}")
    public ApiResult<UserGrade> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(userGradeService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('sys:userGrade:save')")
    @OperationLog
    @Operation(summary = "添加用户会员等级表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody UserGrade userGrade) {
        if (userGradeService.save(userGrade)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:userGrade:update')")
    @OperationLog
    @Operation(summary = "修改用户会员等级表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody UserGrade userGrade) {
        if (userGradeService.updateById(userGrade)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:userGrade:remove')")
    @OperationLog
    @Operation(summary = "删除用户会员等级表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (userGradeService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('sys:userGrade:save')")
    @OperationLog
    @Operation(summary = "批量添加用户会员等级表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<UserGrade> list) {
        if (userGradeService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:userGrade:update')")
    @OperationLog
    @Operation(summary = "批量修改用户会员等级表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<UserGrade> batchParam) {
        if (batchParam.update(userGradeService, "grade_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:userGrade:remove')")
    @OperationLog
    @Operation(summary = "批量删除用户会员等级表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (userGradeService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @Operation(summary = "修改用户会员等级表")
    @PutMapping("/updateGradeId")
    public ApiResult<?> updateGradeId(@RequestBody UserGrade userGrade) {
      final User loginUser = getLoginUser();
      if(loginUser != null){
        if (userGradeService.updateById(userGrade)) {
          return success("修改成功");
        }
      }
      return fail("修改失败");
    }

}
